From: Pavel Reichl <preichl@redhat.com>
To: fstests@vger.kernel.org
Subject: [PATCH v5 1/2] common: new helper to alloacate fixed size files
Date: Thu, 22 Sep 2022 08:38:35 +0200 [thread overview]
Message-ID: <20220922063836.974796-2-preichl@redhat.com> (raw)
In-Reply-To: <20220922063836.974796-1-preichl@redhat.com>
Helper that creates files of specified size using falloc if supported,
otherwise pwrite is used.
Signed-off-by: Pavel Reichl <preichl@redhat.com>
Reviewed-by: Darrick J. Wong <djwong@kernel.org>
---
common/rc | 23 +++++++++++++++++++++++
tests/generic/694 | 8 +++++++-
2 files changed, 30 insertions(+), 1 deletion(-)
diff --git a/common/rc b/common/rc
index a25cbcd0..228fcb37 100644
--- a/common/rc
+++ b/common/rc
@@ -4925,6 +4925,29 @@ hexdump()
_fail "Use _hexdump(), please!"
}
+# Try to create a file with inode->i_blocks >= (length / blocksize).
+# There may be some small overhead, e.g. ext2 filesystem allocates a
+# substantial number of blocks to store block mappings. Those are accounted
+# to i_blocks.
+_create_file_sized()
+{
+ local length=$1
+ local file=$2
+ local tmp=`mktemp -u`
+ local ret=0
+
+ $XFS_IO_PROG -ft -c "falloc 0 $length" $file >$tmp.out 2>&1
+ ret=$?
+ if (grep -Eq "Operation not supported|command .* not found" $tmp.out);then
+ # fallocate isn't supported, fallback to general buffer write
+ $XFS_IO_PROG -ft -c "pwrite 0 $length" $file >$tmp.out 2>&1
+ ret=$?
+ fi
+ [ $ret -ne 0 ] && cat $tmp.out
+ rm -f $tmp.out
+ return $ret
+}
+
init_rc
################################################################################
diff --git a/tests/generic/694 b/tests/generic/694
index dfd988df..c96c2154 100755
--- a/tests/generic/694
+++ b/tests/generic/694
@@ -21,6 +21,9 @@ _cleanup()
}
_supported_fs generic
+_fixed_by_kernel_commit 0c336d6e33f4 \
+ "exfat: fix incorrect loading of i_blocks for large file"
+
_require_test
_require_fs_space $TEST_DIR $((4 * 1024 * 1024)) #kB
@@ -30,7 +33,10 @@ junk_dir=$TEST_DIR/$seq
junk_file=$junk_dir/junk
mkdir -p $junk_dir
-$XFS_IO_PROG -f -c "pwrite -W 0 4G" $junk_file > /dev/null
+_create_file_sized 4G $junk_file
+if [ $? -ne 0 ]; then
+ echo "Could not create 4G test file"
+fi
iblocks=`stat -c '%b' $junk_file`
--
2.37.3
next prev parent reply other threads:[~2022-09-22 6:38 UTC|newest]
Thread overview: 7+ messages / expand[flat|nested] mbox.gz Atom feed top
2022-09-22 6:38 [PATCH v5 0/2] test i_blocks for truncated largefiles Pavel Reichl
2022-09-22 6:38 ` Pavel Reichl [this message]
2022-09-22 14:05 ` [PATCH v5 1/2] common: new helper to alloacate fixed size files Zorro Lang
2022-09-22 16:22 ` Darrick J. Wong
2022-09-22 16:47 ` Pavel Reichl
2022-09-22 6:38 ` [PATCH v5 2/2] generic: test i_blocks for truncated large files Pavel Reichl
2022-09-22 14:06 ` Zorro Lang
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20220922063836.974796-2-preichl@redhat.com \
--to=preichl@redhat.com \
--cc=fstests@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.